#!/usr/bin/python
#
# Lifelines report index1.ll
# Author: Tom Wetmore and Cliff Manis
#
# Python/GEDitCOM II conversion: index1.py
# Author: John A. Nairn
#
# This program produces a report of all INDI's in the database, with
# sorted names as output.

# Load Lifelines Emulation
from lifelines import *

# Preamble
pagemode(64,80)
gdoc = ll_init("index1.ll program")

message("collect persons.")
idx=indiset()
monthformat(4)
for (n,indi) in forindi() :
    addtoset(idx,indi,n)
message("indexed " + d(n+1) + " persons.")
message("begin sorting")
namesort(idx)
message("done sorting")

col(1)
out("======================================================================")
nl()
col(16)
out("INDEX OF ALL PERSONS IN DATABASE")
nl()
nl()
nl()
col(1)
out("LAST, First                       Index #  Birthdate       Deathdate")
nl()
col(1)
out("--------------------------------  -------- ------------    ------------")
nl()

message("compling report...")
(indi,v,n,iter) = forindiset(idx)
while indi :
    col(1)
    out(fullname(indi,1,0,30))
    col(35)
    out(key(indi))
    col(44)
    out(stddate(birth(indi)))
    col(60)
    out(stddate(death(indi)))
    nl()
    (indi,v,n) = forindiset(iter)

# Script output
pageout()
finish()
