#!/usr/bin/python
#
# Lifelines report pedigreeI.ll
# Author: Tom Wetmore and Cliff Manis
#
# Python/GEDitCOM II conversion: pedigreeI.py
# Author: John A. Nairn
#
# select and produce a ancestor report for the person selected.
# Ancestors report format, which print the event in long format.
# Output is an ASCII file, and will probably need to be printed
# using 132 column format.

# Load Lifelines Emulation
from lifelines import *
from operator import add,mul

# Subroutines

def pedigree(inum, ah, indi) :
    par = father(indi)
    if par is not None :
        pedigree(add(1,inum),mul(2,ah),par)
    message(name(indi))
    col(mul(8,inum)+1)
    out(fullname(indi,1,1,50))
    evt = birth(indi)
    if evt is not None :
        out(", b. " + long(evt))
    out(" (" + d(ah) + ")")
    nl()
    par = mother(indi)
    if par is not None :
        pedigree(add(1,inum),add(1,mul(2,ah)),par)

# Preamble
pagemode(64,164)
gdoc = ll_init("pedigreel.ll program")

# main method
indi = getindi()
pedigree(0,1,indi)
pageout()

# Script output
finish()

